Attribute VB_Name = "Common"
Option Explicit

Public Const Pi As Single = 3.14159265358979
Public Const Deg2Rad As Single = (2 * Pi) / 360
Public Const Rad2Deg As Single = 360 / (2 * Pi)
Public Const e As Single = 2.71828182845905

Public Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Public Declare Function GetInputState Lib "user32.dll" () As Long
Public Declare Function timeGetTime Lib "winmm.dll" () As Long
Public Declare Sub Sleep Lib "kernel32.dll" (ByVal dwMilliseconds As Long)
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32.dll" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Public Declare Function GetAsyncKeyState Lib "user32.dll" (ByVal vKey As Long) As Integer
Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Public Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (ByRef Destination As Any, ByVal Length As Long)
Public Declare Function MakeSureDirectoryPathExists Lib "imagehlp.dll" (ByVal DirPath As String) As Long
Public Declare Function PathFileExists Lib "shlwapi.dll" Alias "PathFileExistsA" (ByVal pszPath As String) As Long
Public Declare Function FindFirstFile Lib "kernel32.dll" Alias "FindFirstFileA" (ByVal lpFileName As String, ByRef lpFindFileData As WIN32_FIND_DATA) As Long
Public Const MAX_PATH As Long = 260

Public Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

Public Type WIN32_FIND_DATA
  dwFileAttributes As Long
  ftCreationTime As FILETIME
  ftLastAccessTime As FILETIME
  ftLastWriteTime As FILETIME
  nFileSizeHigh As Long
  nFileSizeLow As Long
  dwReserved0 As Long
  dwReserved1 As Long
  cFileName As String * MAX_PATH
  cAlternate As String * 14
End Type
Public Declare Function FindNextFile Lib "kernel32.dll" Alias "FindNextFileA" (ByVal hFindFile As Long, ByRef lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindClose Lib "kernel32.dll" (ByVal hFindFile As Long) As Long


Private Const BITSPIXEL As Long = 12
Private Const PLANES As Long = 14

Public AppPath As String
Public AppExe As String
Public TemplateFolder As String
Public IDE As Boolean

Public Sub Init()
AppPath = App.Path
If Right$(AppPath, 1) <> "\" Then AppPath = AppPath & "\"
AppExe = AppPath & App.EXEName & ".exe"
TemplateFolder = AppPath & "Template\"

MakeSureDirectoryPathExists TemplateFolder
If PathFileExists(TemplateFolder & "(Empty Project).logo") = 0 Then
  Open TemplateFolder & "(Empty Project).logo" For Output As #1
    Print #1, StrConv(LoadResData("Default", "Template"), vbUnicode);
  Close
End If

Debug.Assert IsIDE
End Sub

Private Function IsIDE() As Long
IsIDE = 1
IDE = True
End Function

Public Function FNE(File As String) As String
FNE = Mid$(File, InStrRev(File, "\") + 1)
End Function

Public Function FPE(File As String) As String
Dim BS As Long
BS = InStrRev(File, "\")
If BS Then FPE = Left$(File, BS - 1)
End Function

Public Function FBE(File As String) As String
FBE = Left$(File, InStrRev(File, ".") - 1)
End Function

Public Sub Wait(Milliseconds As Long)
Dim T As Long
T = timeGetTime
Do Until ((timeGetTime - T) >= Milliseconds) Or Program.bCancel
  Sleep 1
  'If GetInputState Then
  DoEvents
Loop
End Sub

Public Sub Pause()
Turtle.ActiveatePictureHoldMode
Do Until ((Program.State And psfPaused) = 0) Or Program.bCancel
  Sleep 100
  DoEvents
Loop
If Not Program.bCancel Then Turtle.DeactiveatePictureHoldMode
End Sub

Public Function Min(Num1 As Long, Num2 As Long) As Long
If Num1 < Num2 Then Min = Num1 Else Min = Num2
End Function

Public Function ASin(Value As Single) As Single
ASin = Atn(Value / Sqr(-Value * Value + 1))
End Function

Public Function ACos(Value As Single) As Single
'ACos = Atn(-Value / Sqr(-Value * Value + 1)) + 2 * Atn(1)
ACos = 2 * Atn(1) - Atn(Value / Sqr(-Value * Value + 1))
End Function

Public Function Modf(V1 As Single, V2 As Single) As Single
Modf = V1 - (V1 \ V2) * V2
End Function

Public Function GetColorDepth() As Long
Dim hDC As Long
hDC = GetDC(0)
GetColorDepth = GetDeviceCaps(hDC, BITSPIXEL) * GetDeviceCaps(hDC, PLANES)
ReleaseDC 0, hDC
End Function

Public Function RemoveArrayItemStr(A() As String, Index As Long) As String()
'WARNING: Set all Strings in the item to vbNullString (not "" !) before deleting!
'         Zero Based Arrays only!
Dim Arr() As String
Dim UB As Long

Arr = A
UB = UBound(Arr)
If Index <> UB Then
  CopyMemory ByVal VarPtr(Arr(Index)), ByVal VarPtr(Arr(Index + 1)), 4 * (UB - Index)
  ZeroMemory ByVal VarPtr(Arr(UB)), 4
End If

ReDim Preserve Arr(0 To UB - 1)

RemoveArrayItemStr = Arr
End Function

Public Function CreateVariantArray(NumItems As Long) As Variant()
Static v() As Variant
ReDim v(0 To NumItems - 1)
CreateVariantArray = v
End Function
