Attribute VB_Name = "DIBs"
Option Explicit
Private Declare Function GlobalAlloc Lib "kernel32.dll" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalFree Lib "kernel32.dll" (ByVal hMem As Long) As Long

Private Type SAFEARRAYBOUND
  cElements As Long
  lLbound As Long
End Type

Private Type SAFEARRAY2D
  cDims As Integer
  fFeatures As Integer
  cbElements As Long
  cLocks As Long
  pvData As Long
  Bounds(0 To 1) As SAFEARRAYBOUND
End Type

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function CreateDIBSection Lib "gdi32.dll" (ByVal hDC As Long, pBitmapInfo As BITMAPINFO, ByVal un As Long, lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long
Private Declare Function VarPtrArray Lib "msvbvm60.dll" Alias "VarPtr" (Ptr() As Any) As Long
Private Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (Destination As Any, ByVal Length As Long)

Public Type RGBQUAD
  rgbBlue As Byte
  rgbGreen As Byte
  rgbRed As Byte
  rgbReserved As Byte
End Type

Private Type BITMAPINFOHEADER
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type

Private Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColors As RGBQUAD
End Type

Public Type DIB
  hDIB As Long
  Width As Long
  WidthBytes As Long
  Height As Long
  DataPtr As Long
  Header As BITMAPINFO
End Type

Private Const BI_RGB As Long = 0&
Private Const DIB_RGB_COLORS As Long = 0

Public Type RGB
  B As Byte
  G As Byte
  R As Byte
End Type

Public Function CreateDIB(hDC As Long, Width As Long, Height As Long) As DIB
Dim D As DIB

D.Width = Width
D.Height = Height
D.WidthBytes = GetBytesPerScanLine(Width)

With D.Header.bmiHeader
  .biSize = Len(D.Header.bmiHeader)
  .biWidth = D.Width
  .biHeight = -D.Height 'Das Minus ist wichtig! Es veranlasst Windoof das DIB richtig herum im Speicher abzulegen, nicht wie sonst auf dem Kopf!
  .biPlanes = 1
  .biBitCount = 24
  .biCompression = BI_RGB
  .biSizeImage = D.WidthBytes * D.Height
End With

D.hDIB = CreateDIBSection(hDC, D.Header, DIB_RGB_COLORS, D.DataPtr, 0, 0)
CreateDIB = D
End Function

Private Function GetBytesPerScanLine(Width As Long) As Long
GetBytesPerScanLine = ((Width * 3) + 3) And &HFFFFFFFC
End Function

Public Function DestroyDIB(D As DIB)
DeleteObject D.hDIB
End Function

Public Sub CreateDIBAccessArray(D As DIB, A() As RGB)
Dim SA As SAFEARRAY2D

With SA
  .cbElements = 3
  .cDims = 2
  .Bounds(0).cElements = D.Height
  .Bounds(1).cElements = D.WidthBytes \ 3
  .pvData = D.DataPtr
End With

Dim x As Long

x = GlobalAlloc(0, Len(SA))
CopyMemory ByVal x, SA, Len(SA)
CopyMemory ByVal VarPtrArray(A), x, 4
End Sub

Public Sub DestroyDIBAccessArray(A() As RGB)
Dim SA As SAFEARRAY2D
Dim x As Long
CopyMemory x, ByVal VarPtrArray(A), 4
ZeroMemory ByVal VarPtrArray(A), 4
ZeroMemory ByVal x, Len(SA)
GlobalFree x
End Sub

