Attribute VB_Name = "Declares"
Option Explicit

Public Const SB_PANEL_PROGRAM_STATUS As Long = 1
Public Const SB_PANEL_EDIT_CURSOR_POS As Long = 2
Public Const SB_PANEL_CURRENT_PROCEDURE As Long = 3
Public Const SB_PANEL_NUM_ACTIVE_PROCEDURES As Long = 4

Public Const TB_BUTTON_RUN As Long = 13
Public Const TB_BUTTON_PAUSE As Long = 14
Public Const TB_BUTTON_STOP As Long = 15

Public Enum enmProgramState
  psInactive = 0
  psParsing1 = 1
  psParsing2 = 2
  psRunning = 3
  
  psStateMask = 3 'Mask
  psfPaused = 4 'Flag
End Enum

Public Enum enmCancelReason
  crLoopExit = 1
  crProcedureExit = 2
  crProgramExit = 3
  crAppExit = 4
End Enum

Public Enum enmSegmentType
  ptConstant = 1
  ptNativeCommand = 2
  ptVariable = 4
  ptProcedure = 8
  ptOperand = 16
  
  ptBlockIndex = 64
End Enum

Public Type Parameter
  Type As enmSegmentType
  Value As Variant
  ValIndex As Long
End Type

Public Enum enmExpressionOperand
  [eoA+B] = 1
  [eoA-B]
  [eoA*B]
  [eoA/B]
  [eoA^B]
  [eoA=B]
  [eoA<>B]
  [eoA<B]
  [eoA>B]
  [eoA=>B]
  [eoA<=B]
  [eoAAndB]
  [eoAOrB]
  [eoAXorB]
  [eoA&B]
  [eoAModB]
  [eoAModfB]
End Enum

Public Enum enmCommand
  cmdTo = 1
  cmdEnd
  cmdCall
  cmdDim
  cmdConst
  cmdStruct
  cmdRepeat
  cmdWhile
  cmdUntil
  cmdLoop
  cmdIf
  cmdElse
  cmdEndIf
  cmdFD
  cmdBK
  cmdRT
  cmdLT
  cmdSetTurtlePos
  cmdSetTurtleX
  cmdSetTurtleY
  cmdSetTurtleAngle
  cmdGetTurtleX
  cmdGetTurtleY
  cmdGetTurtleAngle
  cmdWait
  cmdPU
  cmdPD
  cmdMake
  cmdAdd
  cmdSub
  cmdMul
  cmdDiv
  cmdRnd
  cmdSin
  cmdCos
  cmdTan
  cmdATan
  cmdASin
  cmdACos
  cmdSqr
  cmdPower
  cmdLog
  cmdLn
  cmdExp
  cmdRound
  cmdFix
  cmdMath
  cmdPC
  cmdPCRGB
  cmdBG
  cmdBGRGB
  cmdSetAlpha
  cmdSetDrawWidth
  cmdFloodFill
  cmdGetPointColor
  cmdST
  cmdHT
  cmdClear
  cmdHome
  cmdDraw
  cmdEnableBackBuffer
  cmdDisableBackBuffer
  cmdEnableAutoUpdate
  cmdDisableAutoUpdate
  cmdUpdate
  cmdMoveDelay
  cmdDrawText
  cmdStrLen
  cmdStrLeft
  cmdStrRight
  cmdStrMid
  cmdAsc
  cmdChr
  cmdString
  cmdSetFont
  cmdPenMode
  cmdKeyDown
  cmdInkey
  cmdPrintConsole
  cmdReturn
  cmdExitLoop
  cmdExitProcedure
  cmdTerminate
  'To be Continued...
End Enum

Public Type Command
  Type As enmSegmentType
  Index As enmCommand
  NumParameters As Long
  Parameters() As Parameter
End Type

Public Type CodeLine
  PrimaryCommand As Long
  TextCodeLine As Long
End Type

Public Enum enmBlockType
  btNormalProcedure = 0
  btLoopBlock = 1
  btIfThenBlock
  btIfElseBlock
End Enum

Public Type bLock
  Type As enmBlockType
  CodeLines() As CodeLine
  NumCodeLines As Long
End Type

Public Type Variable
  Name As String
  Value As Variant
  VarType As Long '-1 means simple Var
End Type

Public Type VariableInfo
  Name As String
  VarType As Long '-1 means simple Var
End Type

Public Type Struct
  Name As String
  NumMembers As Long
  Members() As VariableInfo
End Type

Public Type ComplexAddressArray
  BaseVariable As Long
  NumLevels As Long
  Addresses() As Long
End Type

Public Type Procedure
  Name As String
  
  LocalVariablesInfo() As VariableInfo '<-\
  NumLocalVariables As Long            '<-+
  NumParameters As Long '-----------------/ Included
  
  LocalConstants() As Variable '*ggg*
  NumLocalConstants As Long
  
  StartLine As Long
  EndLine As Long
  
  Blocks() As bLock
  NumBlocks As Long
End Type
