Attribute VB_Name = "INI"
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Public Sub INISetValue(ByVal Path As String, ByVal Sect As String, ByVal Key As String, ByVal Value As String)
  Dim result As Long
    'Wert schreiben
    result = WritePrivateProfileString(Sect, Key, Value, Path)
End Sub

Public Function INIGetValue(ByVal Path As String, ByVal Sect As String, ByVal Key As String, Optional Default As String) As String
  Dim result As Long, Buffer As String
    'Wert lesen
    Buffer = Space$(128)
    result = GetPrivateProfileString(Sect, Key, Default, Buffer, Len(Buffer), Path)
    INIGetValue = Left$(Buffer, result)
End Function

Public Function INISetArray(ByVal Path As String, ByVal Sect As String, xArray() As String)
  Dim Buffer As String, result As Long
    'Feld in einen String mit Trennzeichen Chr$(0) umwandeln
    Buffer = Join$(xArray, vbNullChar)
    
    'String schreiben
    If Right$(Buffer, 1) = vbNullChar Then Buffer = Left$(Buffer, Len(Buffer) - 1)
    result = WritePrivateProfileSection(Sect, Buffer, Path)
End Function

Public Function INIGetArray(ByVal Path As String, ByVal Sect As String, xArray() As String) As Boolean
  Dim result As Long, Buffer As String
    'String lesen
    Buffer = Space$(32767)
    result = GetPrivateProfileSection(Sect, Buffer, Len(Buffer), Path)
    
    Buffer = Left$(Buffer, result)
    
    If Buffer <> "" Then
      xArray = Split(Buffer, vbNullChar)
      INIGetArray = True
    End If
End Function

Public Sub INIDeleteKey(ByVal Path As String, ByVal Sect As String, ByVal Key As String)
  Call WritePrivateProfileString(Sect, Key, 0&, Path)
End Sub
 
Public Sub INIDeleteSection(ByVal Path As String, ByVal Sect As String)
  Call WritePrivateProfileString(Sect, 0&, 0&, Path)
End Sub
