Attribute VB_Name = "Options"
Option Explicit

Public ConfigFile As String

Public SaveVSplitterPos As Boolean
Public SaveHSplitterPos As Boolean
Public XSepFactor As Single
Public YSepFactor As Single

Public DebugMode As Boolean
Public ShowProcedureDetailsWhileParsing As Boolean
Public ShowCurrentLineWhileParsing As Boolean
Public ParserDelay As Long
Public ShowProcedureDetailsWhileRunning As Boolean
Public ShowCurrentLineWhileRunning As Boolean
Public InterpreterDelay As Long

Public TabWidth As Long
Public IntelliSense As Boolean

Public ClearConsoleBeforeRun As Boolean

Public ShowTipsAtStartup As Boolean
Public LastTipIndex As Long

Public Enum enmStartupAction
  suaShowDialog = 0
  suaLoadTemplate = 1
  suaLoadLastFile = 2
  suaLoadSpecificFile = 3
End Enum
  
Public StartupAction As enmStartupAction
Public StartupFile As String

Public AutoFileAssociate As Boolean

Public FirstStart As Boolean

Public Sub Load()
ConfigFile = Common.AppPath & "PLogo.ini"

SaveVSplitterPos = CBool(Val(INI.INIGetValue(ConfigFile, "Window", "SaveVSplitterPos", 1)))
SaveHSplitterPos = CBool(Val(INI.INIGetValue(ConfigFile, "Window", "SaveHSplitterPos", 1)))
XSepFactor = Val(INI.INIGetValue(ConfigFile, "Window", "XSepFactor", "0.28"))
YSepFactor = Val(INI.INIGetValue(ConfigFile, "Window", "YSepFactor", "0.805"))

TabWidth = Val(INI.INIGetValue(ConfigFile, "CodeEditor", "TabWidth", 2))
IntelliSense = CBool(Val(INI.INIGetValue(ConfigFile, "CodeEditor", "IntelliSense", 1)))

ClearConsoleBeforeRun = CBool(Val(INI.INIGetValue(ConfigFile, "Console", "ClearConsoleBeforeRun", 1)))

ShowTipsAtStartup = CBool(Val(INI.INIGetValue(ConfigFile, "Tips", "ShowTipsAtStartup", 1)))
LastTipIndex = Val(INI.INIGetValue(ConfigFile, "Tips", "LastTipIndex", 0))

StartupAction = Val(INI.INIGetValue(ConfigFile, "Startup", "StartupAction", suaShowDialog))
StartupFile = INI.INIGetValue(ConfigFile, "Startup", "StartupFile", "")

AutoFileAssociate = CBool(Val(INI.INIGetValue(ConfigFile, "FileAssociation", "AutoFileAssociate", 0)))

FirstStart = CBool(Val(INI.INIGetValue(ConfigFile, "App", "FirstStart", 1)))
End Sub

Public Sub Save()
INI.INISetValue ConfigFile, "Window", "SaveVSplitterPos", -CLng(SaveVSplitterPos)
INI.INISetValue ConfigFile, "Window", "SaveHSplitterPos", -CLng(SaveHSplitterPos)
If SaveVSplitterPos Then INI.INISetValue ConfigFile, "Window", "XSepFactor", Replace$(CStr(XSepFactor), ",", ".", , 1)
If SaveHSplitterPos Then INI.INISetValue ConfigFile, "Window", "YSepFactor", Replace$(CStr(YSepFactor), ",", ".", , 1)

INI.INISetValue ConfigFile, "CodeEditor", "TabWidth", TabWidth
INI.INISetValue ConfigFile, "CodeEditor", "IntelliSense", -CLng(IntelliSense)

INI.INISetValue ConfigFile, "Console", "ClearConsoleBeforeRun", -CLng(ClearConsoleBeforeRun)

INI.INISetValue ConfigFile, "Tips", "ShowTipsAtStartup", -CLng(ShowTipsAtStartup)
INI.INISetValue ConfigFile, "Tips", "LastTipIndex", LastTipIndex

INI.INISetValue ConfigFile, "Startup", "StartupAction", StartupAction
INI.INISetValue ConfigFile, "Startup", "StartupFile", StartupFile

INI.INISetValue ConfigFile, "FileAssociation", "AutoFileAssociate", -CLng(AutoFileAssociate)

INI.INISetValue ConfigFile, "App", "FirstStart", 0
End Sub
