Attribute VB_Name = "Program"
Option Explicit

Public Code() As String

Public Commands() As Command
Public NumCommands As Long

Public GlobalVariables() As Variable
Public NumGlobalVariables As Long

Public GlobalConstants() As Variable  '*ggg*
Public NumGlobalConstants As Long

Public Structs() As Struct
Public NumStructs As Long

Public ComplexAddressArrays() As ComplexAddressArray
Public NumComplexAddressArrays As Long

Public Procedures() As Procedure
Public NumProcedures As Long

Public MainProcedure As Long


Public bCancel As Boolean
Public CancelReason As enmCancelReason

Public State As enmProgramState

Public Const vfPublic As Long = &H40000000
Public Const vfComplexAddress As Long = &H80000000
Public Const vfVarIndex As Long = &H3FFFFFFF

Public Sub Clear()
Erase Code

Erase Commands
NumCommands = 0

Erase GlobalVariables
NumGlobalVariables = 0

Erase GlobalConstants
NumGlobalConstants = 0

Erase Procedures
NumProcedures = 0

Erase Structs
NumStructs = 0

Erase ComplexAddressArrays
NumComplexAddressArrays = 0

MainProcedure = -1

bCancel = False
State = psInactive
End Sub

Public Function AddCommand(C As Command, TextCodeLine As Long, Optional OwnerProcedure As Long = -1, Optional ProcedureBlock As Long = -1) As Long
Dim CmdIndex As Long

NumCommands = NumCommands + 1
ReDim Preserve Commands(0 To NumCommands - 1)
CmdIndex = NumCommands - 1
Commands(CmdIndex) = C

AddCommand = CmdIndex

If OwnerProcedure <> -1 Then
  With Procedures(OwnerProcedure).Blocks(ProcedureBlock)
    .NumCodeLines = .NumCodeLines + 1
    ReDim Preserve .CodeLines(0 To .NumCodeLines - 1)
    .CodeLines(.NumCodeLines - 1).PrimaryCommand = CmdIndex
    .CodeLines(.NumCodeLines - 1).TextCodeLine = TextCodeLine
  End With
End If
End Function

Public Function AddVariable(Name As String, VarType As Long, Procedure As Long, IsProcParameter As Boolean) As Long
If Procedure <> -1 Then 'Local
  With Procedures(Procedure)
    .NumLocalVariables = .NumLocalVariables + 1
    ReDim Preserve .LocalVariablesInfo(0 To .NumLocalVariables - 1)
    .LocalVariablesInfo(.NumLocalVariables - 1).Name = Name
    .LocalVariablesInfo(.NumLocalVariables - 1).VarType = VarType
    
    AddVariable = .NumLocalVariables - 1
    
    If IsProcParameter Then .NumParameters = .NumParameters + 1
  End With
Else 'Global
  NumGlobalVariables = NumGlobalVariables + 1
  ReDim Preserve GlobalVariables(0 To NumGlobalVariables - 1)
  GlobalVariables(NumGlobalVariables - 1).Name = Name
  GlobalVariables(NumGlobalVariables - 1).VarType = VarType
  
  AddVariable = (NumGlobalVariables - 1) Or vfPublic
End If
End Function

Public Function AddStruct(Name As String, NumMembers As Long, Members() As VariableInfo) As Long
NumStructs = NumStructs + 1
ReDim Preserve Structs(0 To NumStructs - 1)
With Structs(NumStructs - 1)
  .Name = Name
  .NumMembers = NumMembers
  .Members = Members
End With

AddStruct = NumStructs - 1
End Function

Public Function AddConstant(Group As enmConstantsGroups, Name As String, Value As Variant, Procedure As Long) As Long
If Procedure <> -1 Then 'Local
  With Procedures(Procedure)
    .NumLocalConstants = .NumLocalConstants + 1
    ReDim Preserve .LocalConstants(0 To .NumLocalConstants - 1)
    .LocalConstants(.NumLocalConstants - 1).Name = Name
    .LocalConstants(.NumLocalConstants - 1).Value = Value
    
    AddConstant = .NumLocalConstants - 1
  End With
Else 'Global
  NumGlobalConstants = NumGlobalConstants + 1
  ReDim Preserve GlobalConstants(0 To NumGlobalConstants - 1)
  GlobalConstants(NumGlobalConstants - 1).Name = Name
  GlobalConstants(NumGlobalConstants - 1).Value = Value
  
  AddConstant = NumGlobalConstants - 1
End If
End Function

Public Function AddBlock(BlockType As enmBlockType, Procedure As Long) As Long
With Procedures(Procedure)
  .NumBlocks = .NumBlocks + 1
  ReDim Preserve .Blocks(0 To .NumBlocks - 1)
  AddBlock = .NumBlocks - 1
  .Blocks(AddBlock).Type = BlockType
End With
End Function

Public Function AddComplexAddressArray(BaseVariable As Long, NumLevels As Long, Addresses() As Long) As Long
NumComplexAddressArrays = NumComplexAddressArrays + 1
ReDim Preserve ComplexAddressArrays(0 To NumComplexAddressArrays - 1)
With ComplexAddressArrays(NumComplexAddressArrays - 1)
  .BaseVariable = BaseVariable
  .NumLevels = NumLevels
  .Addresses = Addresses
End With

AddComplexAddressArray = NumComplexAddressArrays - 1
End Function
