Attribute VB_Name = "Reg"
Option Explicit


Private Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal HKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal HKey As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal HKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Any) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal HKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Any, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegFlushKey Lib "advapi32.dll" (ByVal HKey As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal HKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Long, ByVal cbData As Long) As Long
Private Declare Function RegSetValueEx_Str Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal HKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal HKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal HKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal HKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

Private Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" (ByVal HKey As Long, ByVal lpClass As String, lpcbClass As Long, ByVal lpReserved As Long, lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, lpcbMaxClassLen As Long, lpcValues As Long, lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, lpftLastWriteTime As Long) As Long
Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal HKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long

Public Enum MainKeys
    HKEY_USERS = &H80000003  'Current Users Hauptschlssel
    HKEY_PERFORMANCE_DATA = &H80000004  '(Win NT/2000) Performance Data schlssel
    HKEY_LOCAL_MACHINE = &H80000002  'Local Machine Schlssel
    HKEY_DYN_DATA = &H80000006  '(Win 95/98) Dynamisch Daten
    HKEY_CURRENT_USER = &H80000001  'Current User Schlssel
    HKEY_CURRENT_CONFIG = &H80000005  'Current Config Schlssel
    HKEY_CLASSES_ROOT = &H80000000
End Enum

Public Enum DataType
    REG_BINARY = 3 'Eine Bytefolge
    REG_DWORD = 4 'Ein 32-Bit Integer wert (Little Endian)
    REG_SZ = 1 'Ein VBNullChar-Zeichen Terminierter String
End Enum

Private Enum Priv_Datentypen
    REG_DWORD_BIG_ENDIAN = 5 'Ein 32-Bit Integer (Big Endian)
    REG_EXPAND_SZ = 2 'Ein VBNullChar Terminierter String der Umgebungsvariablen enthlt
    REG_LINK = 6 'Ein Unicode symbolischer Link
    REG_MULTI_SZ = 7 'Eine Serie von Strings, jedes getrennt mit einem VBNullChar-Zeichen und das ende mit 2 VBNullChar-Zeichen
    REG_NONE = 0 'Keine Daten
    REG_RESOURCE_LIST = 8 'Eine liste von Ressourcen in einer Ressourcen Map
End Enum

Const KEY_ALL_ACCESS = &HF003F  'Alle arten von Zurgiffen
Const KEY_CREATE_LINK = &H20  'Erlaubnis zum Symbolischen erstellen von Links
Const KEY_CREATE_SUB_KEY = &H4  'Erlaubnis zum unterschlssel erstellen
Const KEY_ENUMERATE_SUB_KEYS = &H8  'Erlaubnis zum Enumerieren der Unterschlssel
Const KEY_NOTIFY = &H10  'Erlaubnis ber nderungen benachritet zu werden
Const KEY_QUERY_VALUE = &H1  'Erlaubnis zum Auslesen von Unterschlssel Daten
Const KEY_READ = &H20019  'Lese zugriff
Const KEY_SET_VALUE = &H2  'Erlaubnis zum Schreiben von werten in Unterschlsseln
Const KEY_WRITE = &H20006  'Schreib zugriff

Private Const ERROR_SUCCESS = 0&
Private Const ERROR_NO_MORE_ITEMS = 259&
Private Const REG_OPTION_NON_VOLATILE = &H0

Private Const BsChar = "\"

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Function SetValue(ByVal MainKey As MainKeys, ByVal Subkey As String, ByVal Field As String, ByVal Value As Variant, ByVal Datentyp As DataType) As Integer

Dim result As Long, HKey As Long, S$, L As Long
    'Wert in ein Feld der Registry schreiben
    
On Error GoTo ErrHandler

result = RegOpenKeyEx(MainKey, Subkey, 0, KEY_ALL_ACCESS, HKey)
If result = ERROR_SUCCESS Then
   Select Case Datentyp
    Case REG_SZ, REG_BINARY
        S = CStr(Value)
        If Value = "" Then
           result = RegSetValueEx(HKey, Field, 0, Datentyp, 0, 0)
        Else
           result = RegSetValueEx_Str(HKey, Field, 0, Datentyp, S, Len(S) + 1)
        End If
    Case REG_DWORD
        L = CLng(Value)
        result = RegSetValueEx(HKey, Field, 0, Datentyp, L, 4)
   End Select
   result = RegCloseKey(HKey)
End If
If result = 0 Then SetValue = 1
Exit Function

ErrHandler:
If Err.Number = 13 Then
   SetValue = 2
Else
   SetValue = 0
End If

'Rckgabewerte:
'0 = Fehler
'1 = OK, Wert gesetzt
'2 = Fehler, falsches Datentyp

End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Function GetValue(ByVal MainKey As MainKeys, ByVal Subkey As String, ByVal Field As String, Optional ByRef backDatentyp As Long) As Variant

Dim HKey As Long, Lng As Long, result As Long, L As Long
Dim Buffer$
Dim Datentyp As Long

'Wert aus einem Feld der Registry auslesen
result = RegOpenKeyEx(MainKey, Subkey, 0, KEY_READ, HKey)
If result = ERROR_SUCCESS Then
   result = RegQueryValueEx(HKey, Field, 0&, Datentyp, ByVal 0&, L)
   If result = ERROR_SUCCESS Then
      Select Case Datentyp
        Case REG_SZ, REG_EXPAND_SZ, REG_LINK, REG_MULTI_SZ, REG_NONE, REG_RESOURCE_LIST, REG_BINARY
           Buffer = Space$(L - 1)
           result = RegQueryValueEx(HKey, Field, 0&, Datentyp, ByVal Buffer, L)
           If result = ERROR_SUCCESS Then GetValue = Buffer
        Case REG_DWORD, REG_DWORD_BIG_ENDIAN
           result = RegQueryValueEx(HKey, Field, 0&, Datentyp, Lng, L)
           If result = ERROR_SUCCESS Then GetValue = Lng
      End Select
   End If
End If

If Not IsMissing(backDatentyp) Then backDatentyp = Datentyp

If result <> ERROR_SUCCESS Then
   GetValue = vbNullString
   backDatentyp = 0
End If

result = RegCloseKey(HKey)

End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Function GetAllValues(ByVal MainKey As MainKeys, ByVal Subkey As String) As String()

Dim HKey As Long, Cnt As Long, sName As String, sData As String, Ret As Long, RetData As Long
Const BUFFER_SIZE As Long = 255
Dim Datentyp As Long
Dim j As Integer
Dim L As Long
Dim Temp As String
Dim TempArray As Variant, Feld() As String
Dim Lng As Long, result As Long
Dim Buffer$
    
Cnt = 0
'Open a registry key
If RegOpenKeyEx(MainKey, Subkey, 0, KEY_READ, HKey) = 0 Then
   'initialize
   sName = Space(BUFFER_SIZE)
   sData = Space(BUFFER_SIZE)
   Ret = BUFFER_SIZE
   RetData = BUFFER_SIZE
   'enumerate the values
   While RegEnumValue(HKey, Cnt, sName, Ret, 0, ByVal 0&, ByVal sData, RetData) <> ERROR_NO_MORE_ITEMS
        'show data
        If RetData > 0 Then
           Temp = Temp & Left(sName, Ret)
           Temp = Temp & Chr(13) & GetValue(MainKey, Subkey, Left(sName, Ret), Datentyp)
           Temp = Temp & Chr(13) & CStr(Datentyp) & Chr(13)
        End If
        
        'prepare for next value
        Cnt = Cnt + 1
        sName = Space(BUFFER_SIZE)
        sData = Space(BUFFER_SIZE)
        Ret = BUFFER_SIZE
        RetData = BUFFER_SIZE
   Wend
   'Close the registry key
   RegCloseKey HKey
   ReDim Feld(Cnt, 2)
   TempArray = Split(Temp, Chr(13))
   For j = 0 To UBound(TempArray) - 3 Step 3
       Feld(j / 3, 0) = TempArray(j)
       Feld(j / 3, 1) = TempArray(j + 1)
       Feld(j / 3, 2) = TempArray(j + 2)
   Next
   GetAllValues = Feld
End If
    
End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Function CreateKey(ByVal MainKey As MainKeys, ByVal Subkey As String) As Integer

Dim result&, HKey&, Back&
'Neuen Schlssel erstellen
result = RegCreateKeyEx(MainKey, Subkey, 0, vbNullString, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 0&, HKey, Back)
If result = ERROR_SUCCESS Then
   result = RegFlushKey(HKey)
   If result = ERROR_SUCCESS Then Call RegCloseKey(HKey)
   CreateKey = Back
End If

'Rckgabewerte:
'0: Fehler beim Erstellen
'1: OK, neu erstellt
'2: OK, existierte bereits

End Function

Public Function KeyExist(ByVal MainKey As MainKeys, ByVal Subkey As String) As Boolean

Dim result&, HKey&
'Prfen ob ein Schlssel existiert
result = RegOpenKeyEx(MainKey, Subkey, 0, KEY_READ, HKey)
If result = ERROR_SUCCESS Then Call RegCloseKey(HKey)
If result = 0 Then KeyExist = True

End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Function DeleteKey(ByVal MainKey As MainKeys, ByVal Subkey As String) As Boolean
 DeleteKey = RegDelKeyAndSubkeys(MainKey, Subkey)
End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Function DeleteValue(ByVal MainKey As MainKeys, ByVal Subkey As String, ByVal Field As String) As Boolean

Dim result&, HKey&
'Feld lschen
result = RegOpenKeyEx(MainKey, Subkey, 0, KEY_ALL_ACCESS, HKey)
If result = ERROR_SUCCESS Then
   result = RegDeleteValue(HKey, Field)
End If

If result = 0 Then DeleteValue = True

result = RegCloseKey(HKey)

End Function


Private Function RegDelKey(MainKey As Long, Subkey As String, Optional KeyToKill As String) As Boolean
'### lscht einen Schlssel (1 Ebene)
Dim rc As Long
Dim HKey As Long
Dim KeyArray() As String
Dim LocalSubKey As String
Dim LocalKeyToKill As String
    '### letzte Ebene muss API isoliert bergeben werden
    If Len(KeyToKill) Then
        '### schon gesplittet
        LocalSubKey = Subkey
        LocalKeyToKill = KeyToKill
    Else
        '### noch splitten
        KeyArray = Split(Subkey, BsChar)
        LocalKeyToKill = KeyArray(UBound(KeyArray))
        If UBound(KeyArray) Then
            ReDim Preserve KeyArray(UBound(KeyArray) - 1)
            LocalSubKey = Join(KeyArray, BsChar)
        Else
            LocalSubKey = ""
        End If
    End If
    '### Schlssel ffnen
    rc = RegOpenKeyEx(MainKey, LocalSubKey, 0, KEY_ALL_ACCESS, HKey)
    '### Einen Schlssel lschen
    rc = RegDeleteKey(HKey, LocalKeyToKill)
    If rc = 0 Then RegDelKey = True
    '### Schlssel schlieen
    rc = RegCloseKey(HKey)
End Function

Private Function RegDelKeyAndSubkeys(MainKey As Long, Subkey As String, Optional KeyToKill As String) As Boolean
'### lscht einen Schlssel (alle gegeb. Ebenen)
Dim i As Long
Dim rc As Long
Dim HKey As Long
Dim LocalSubKey As String
Dim KeysInThisLevel() As String
    '### Schlsselnamen aufbereiten
    LocalSubKey = Subkey
    If Len(KeyToKill) Then LocalSubKey = LocalSubKey + BsChar + KeyToKill
    '### alle Schlsselnamen UNTER dem aktuellen Schlssel einsammeln
    RegQueryAllKeys MainKey, LocalSubKey, KeysInThisLevel
    '### evtl. gefundene Unterschlssel lschen
    For i = 1 To UBound(KeysInThisLevel)
        '### rek. Aufruf
        RegDelKeyAndSubkeys MainKey, LocalSubKey, KeysInThisLevel(i)
    Next
    '### jetzt noch den aktuellen Schlssel lschen
    If RegDelKey(MainKey, LocalSubKey) Then RegDelKeyAndSubkeys = True
End Function

Private Sub RegQueryAllKeys(MainKey As Long, Subkey As String, KeyArray() As String)
'### alle Schlsselnamen UNTER dem aktuellen Schlssel einsammeln
Dim i As Long
Dim rc As Long
Dim HKey As Long
Dim KeyMaxIndex As Long
Dim KeyMaxNameLen As Long
Dim KeyCurrNameLen As Long
Dim LastChange As FILETIME
    '### Schlssel ffnen
    rc = RegOpenKeyEx(MainKey, Subkey, 0, KEY_ALL_ACCESS, HKey)
    '### Maximalwerte abfragen
    rc = RegQueryInfoKey(HKey, 0, 0, 0, KeyMaxIndex, KeyMaxNameLen, 0, 0, 0, 0, 0, 0)
    '### Namenslnge anpassen
    KeyMaxNameLen = KeyMaxNameLen + 1
    '### bergabe-Array auf Gre bringen
    ReDim KeyArray(0 To KeyMaxIndex) As String
    '### Alle Unterschlsselnamen ins Array schieben
    For i = 1 To KeyMaxIndex
        KeyArray(i) = Space(KeyMaxNameLen)
        KeyCurrNameLen = KeyMaxNameLen
        '### Einzelnamen per Index abfragen
        rc = RegEnumKeyEx(HKey, i - 1, KeyArray(i), KeyCurrNameLen, 0, 0, 0, LastChange)
        KeyArray(i) = Left(KeyArray(i), KeyCurrNameLen)
    Next
    '### Schlssel schlieen
    rc = RegCloseKey(HKey)
End Sub

