Attribute VB_Name = "Turtle"
Option Explicit
Private Declare Function LineTo Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function MoveToEx Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByRef lpPoint As Any) As Long
Private Declare Function Polyline Lib "gdi32.dll" (ByVal hdc As Long, ByRef lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Declare Function timeGetTime Lib "winmm.dll" () As Long
Private Declare Function GetInputState Lib "user32.dll" () As Long
Private Declare Function GetPixel Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function SetPixelV Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Private Declare Function LineDDA Lib "gdi32.dll" (ByVal nXStart As Long, ByVal nYStart As Long, ByVal nXEnd As Long, ByVal nYEnd As Long, ByVal lpLineFunc As Long, lpData As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Function BitBlt Lib "gdi32.dll" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function TextOut Lib "gdi32.dll" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal nHeight As Long, ByVal nWidth As Long, ByVal nEscapement As Long, ByVal nOrientation As Long, ByVal fnWeight As Long, ByVal fdwItalic As Boolean, ByVal fdwUnderline As Boolean, ByVal fdwStrikeOut As Boolean, ByVal fdwCharSet As Long, ByVal fdwOutputPrecision As Long, ByVal fdwClipPrecision As Long, ByVal fdwQuality As Long, ByVal fdwPitchAndFamily As Long, ByVal lpszFace As String) As Long
Private Const FONT_BOLD As Long = 700
Private Const FONT_NONBOLD As Long = 400
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function DrawTextA Lib "user32.dll" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, ByRef lpRect As Any, ByVal wFormat As Long) As Long
Private Declare Function ExtFloodFill Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long, ByVal wFillType As Long) As Long
Private Const FLOODFILLSURFACE As Long = 1


Private Const DT_NOCLIP As Long = &H100
Private Const DT_NOPREFIX As Long = &H800
Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Type RGBQUAD
  rgbBlue As Byte
  rgbGreen As Byte
  rgbRed As Byte
  rgbReserved As Byte
End Type


Public Type POINTAPI
  x As Long
  y As Long
End Type

Private Width As Long
Private Height As Long

Private PenDown As Boolean
Private x As Single
Private y As Single
Private Angle As Single
Private PenColor As Long
Private PenMode As DrawModeConstants
Private BackColor As Long
Private Alpha As Long
Private DrawWidth As Long
Private ShowTurtle As Boolean
Private MoveDelay As Long

Private FontName As String
Private FontSize As Long
Private FontBold As Boolean

Private UseBackBuffer As Boolean
Private AutoUpdate As Boolean

Private hdc As Long

Private PrimarySurface As PictureBox
Private BackBuffer As PictureBox
Private PB As PictureBox

Private PictureHoldMode As Boolean

Public Sub Init()
Set PrimarySurface = Form1.picDraw
Set PB = PrimarySurface
Set BackBuffer = Form1.Controls.Add("VB.PictureBox", "picBackBuffer")
BackBuffer.TabStop = False
BackBuffer.BorderStyle = 0
BackBuffer.ScaleMode = vbPixels
BackBuffer.AutoRedraw = True
BackBuffer.FillStyle = vbFSSolid
Call Resize
End Sub

Public Sub Resize()
Width = PrimarySurface.ScaleWidth
Height = PrimarySurface.ScaleHeight
BackBuffer.Width = Width
BackBuffer.Height = Height

Call Reset
End Sub

Public Sub Reset()
PenDown = True
ShowTurtle = True
Call SetBackBuffer(False)
Call DeactiveatePictureHoldMode
AutoUpdate = False
MoveDelay = 0
Alpha = 255
Call SetPenMode(vbCopyPen)
Call SetDrawWidth(1)
Call ChangeBackgroundColor(vbWhite)
Call ChangePenColor(vbBlack)
x = Width \ 2
y = Height \ 2
Angle = 0

FontName = "Arial"
FontSize = 20
FontBold = False

hdc = PB.hdc
Call Clear
End Sub

Public Sub Clear()
PB.Cls
Set PB.Picture = Nothing
hdc = PB.hdc

MoveToEx hdc, CLng(x), CLng(y), ByVal 0 'Cls resets Cursor Pos
If ShowTurtle Then Call DrawTurtle

If UseBackBuffer And AutoUpdate Then Call Update
End Sub

Public Sub ActiveatePictureHoldMode()
If PictureHoldMode = False Then
  Dim hVisibleDC As Long
  PrimarySurface.AutoRedraw = True
  hVisibleDC = GetDC(PrimarySurface.hwnd)
  BitBlt PrimarySurface.hdc, 0, 0, Width, Height, hVisibleDC, 0, 0, vbSrcCopy
  ReleaseDC PrimarySurface.hwnd, hVisibleDC
  PictureHoldMode = True
End If
End Sub

Public Sub DeactiveatePictureHoldMode()
If PictureHoldMode Then
  PrimarySurface.AutoRedraw = False
  PictureHoldMode = False
End If
End Sub

Public Sub MoveHome()
If ShowTurtle Then Call DrawTurtle
x = Width \ 2
y = Height \ 2
Angle = 0
If PenDown Then
  LineTo hdc, CLng(x), CLng(y)
Else
  MoveToEx hdc, CLng(x), CLng(y), ByVal 0
End If
If ShowTurtle Then Call DrawTurtle

If UseBackBuffer And AutoUpdate Then Call Update
End Sub

Public Sub MoveForward(Distance As Single)
Dim DX As Single
Dim DY As Single
Dim T As Long
T = timeGetTime

DX = Distance * Sin(Angle * Deg2Rad)
DY = -Distance * Cos(Angle * Deg2Rad)

If ShowTurtle Then Call DrawTurtle

If Alpha >= 255 Then
  x = x + DX
  y = y + DY
  
  If PenDown Then
    LineTo hdc, x, y
  Else
    MoveToEx hdc, CLng(x), CLng(y), ByVal 0
  End If
Else
  If PenDown Then Call LineAlpha(CLng(x), CLng(y), CLng(x + DX), CLng(y + DY))
  x = x + DX
  y = y + DY
  MoveToEx hdc, CLng(x), CLng(y), ByVal 0
End If
If ShowTurtle Then Call DrawTurtle

If UseBackBuffer And AutoUpdate Then Call Update

If MoveDelay Then
  Do Until ((timeGetTime - T) >= MoveDelay) Or Program.bCancel
    Sleep 1
    If GetInputState Then DoEvents
  Loop
End If
End Sub

Public Sub DrawText(Text As String)
Static hFont As Long
Static hOldFont As Long
Static R As RECT
hFont = CreateFont(-FontSize, 0, -CLng(Angle * 10), 0, IIf(FontBold, FONT_BOLD, FONT_NONBOLD), 0, 0, 0, 1, 4, &H10, 2, 4, FontName)
hOldFont = SelectObject(hdc, hFont)

'TextOut hdc, X, Y, Text, Len(Text)
R.Left = x
R.Top = y
DrawTextA hdc, Text, Len(Text), R, DT_NOCLIP Or DT_NOPREFIX

SelectObject hdc, hOldFont
DeleteObject hFont
End Sub

Public Sub FloodFill()
If ShowTurtle Then Call DrawTurtle

PB.FillColor = PenColor
'hdc = PB.hdc
ExtFloodFill hdc, CLng(x), CLng(y), GetPixel(hdc, CLng(x), CLng(y)), FLOODFILLSURFACE

If ShowTurtle Then Call DrawTurtle

If UseBackBuffer And AutoUpdate Then Call Update
End Sub

Public Function GetCurrentPointColor() As Long
If ShowTurtle Then Call DrawTurtle
'PB.POINT(x, y)
GetCurrentPointColor = GetPixel(PB.hdc, CLng(x), CLng(y))
If ShowTurtle Then Call DrawTurtle
End Function

Public Sub SetFont(NewFontName As String, NewFontSize As Long, NewFontBold As Boolean)
FontName = NewFontName
FontSize = NewFontSize
FontBold = NewFontBold
End Sub

Private Sub LineAlpha(SX As Long, SY As Long, DX As Long, DY As Long)
Dim C As RGBQUAD
If SX <> DY Or SY <> DY Then
  hdc = hdc
  LineDDA SX, SY, DX, DY, AddressOf LineAlpha_LineDDAProc, PenColor
End If
CopyMemory C, PenColor, 4
Call LineAlpha_LineDDAProc(DX, DY, C)
End Sub

Private Sub LineAlpha_LineDDAProc(ByVal x As Long, ByVal y As Long, lpData As RGBQUAD)
Dim C As Long
Dim R As Long
Dim G As Long
Dim B As Long
C = GetPixel(hdc, x, y)
R = C And &HFF&
G = (C And &HFF00&) \ &H100&
B = (C And &HFF0000) \ &H10000
R = ((R * (255& - Alpha)) \ 255&) + ((CLng(lpData.rgbRed) * Alpha) \ 255&)
G = ((G * (255& - Alpha)) \ 255&) + ((CLng(lpData.rgbGreen) * Alpha) \ 255&)
B = ((B * (255& - Alpha)) \ 255&) + ((CLng(lpData.rgbBlue) * Alpha) \ 255&)
SetPixelV hdc, x, y, (R Or G * &H100& Or B * &H10000)
End Sub

Public Sub TurnRight(TurnAngle As Single)
Dim T As Long
T = timeGetTime

If ShowTurtle Then Call DrawTurtle
Angle = Angle + TurnAngle
If Angle >= 360 Then Angle = Angle - 360
If Angle < 0 Then Angle = Angle + 360

If ShowTurtle Then Call DrawTurtle

If UseBackBuffer And AutoUpdate Then Call Update

If MoveDelay Then
  Do Until ((timeGetTime - T) >= MoveDelay) Or Program.bCancel
    Sleep 1
    If GetInputState Then DoEvents
  Loop
End If
End Sub

Public Sub SetPos(NewX As Single, NewY As Single)
Dim T As Long
T = timeGetTime

If ShowTurtle Then Call DrawTurtle
x = (Width \ 2) + NewX
y = (Height \ 2) - NewY
If PenDown Then
  LineTo hdc, CLng(x), CLng(y)
Else
  MoveToEx hdc, CLng(x), CLng(y), ByVal 0
End If
If ShowTurtle Then Call DrawTurtle

If UseBackBuffer And AutoUpdate Then Call Update

If MoveDelay Then
  Do Until ((timeGetTime - T) >= MoveDelay) Or Program.bCancel
    Sleep 1
    If GetInputState Then DoEvents
  Loop
End If
End Sub

Public Sub SetX(NewX As Single)
Dim T As Long
T = timeGetTime

If ShowTurtle Then Call DrawTurtle
x = (Width \ 2) + NewX
If PenDown Then
  LineTo hdc, CLng(x), CLng(y)
Else
  MoveToEx hdc, CLng(x), CLng(y), ByVal 0
End If
If ShowTurtle Then Call DrawTurtle

If UseBackBuffer And AutoUpdate Then Call Update

If MoveDelay Then
  Do Until ((timeGetTime - T) >= MoveDelay) Or Program.bCancel
    Sleep 1
    If GetInputState Then DoEvents
  Loop
End If
End Sub

Public Sub SetY(NewY As Single)
Dim T As Long
T = timeGetTime

If ShowTurtle Then Call DrawTurtle
y = (Height \ 2) - NewY
If PenDown Then
  LineTo hdc, CLng(x), CLng(y)
Else
  MoveToEx hdc, CLng(x), CLng(y), ByVal 0
End If
If ShowTurtle Then Call DrawTurtle

If UseBackBuffer And AutoUpdate Then Call Update

If MoveDelay Then
  Do Until ((timeGetTime - T) >= MoveDelay) Or Program.bCancel
    Sleep 1
    If GetInputState Then DoEvents
  Loop
End If
End Sub


Public Sub SetAngle(NewAngle As Single)
If ShowTurtle Then Call DrawTurtle
Angle = NewAngle
If ShowTurtle Then Call DrawTurtle

If UseBackBuffer And AutoUpdate Then Call Update
End Sub

Public Function GetX() As Single
GetX = x - CSng(Width \ 2)
End Function

Public Function GetY() As Single
GetY = CSng(Height \ 2) - y
End Function

Public Function GetAngle() As Single
GetAngle = Angle
End Function

Public Sub SetPen(bDown As Boolean)
PenDown = bDown
End Sub

Public Sub ChangePenColor(NewColor As Long)
If PenColor <> NewColor Then
  If ShowTurtle Then Call DrawTurtle
  PenColor = NewColor
  PB.ForeColor = PenColor
  If ShowTurtle Then Call DrawTurtle
  
  If UseBackBuffer And AutoUpdate Then Call Update
End If
End Sub

Public Sub SetPenMode(NewPenMode As DrawModeConstants)
If NewPenMode <> PenMode Then
  PenMode = NewPenMode
  PB.DrawMode = PenMode
  hdc = PB.hdc
End If

End Sub

Public Sub ChangeBackgroundColor(NewColor As Long)
If BackColor <> NewColor Then
  BackColor = NewColor
  PB.BackColor = NewColor
  hdc = PB.hdc
  MoveToEx hdc, CLng(x), CLng(y), ByVal 0 'Changeing Background resets Cursor Pos
  If ShowTurtle Then Call DrawTurtle
  
  If UseBackBuffer And AutoUpdate Then Call Update
End If
End Sub

Public Sub SetAlpha(NewAlpha As Long)
Alpha = NewAlpha
End Sub

Public Sub SetDrawWidth(NewDrawWidth As Long)
If NewDrawWidth <> DrawWidth Then
  DrawWidth = NewDrawWidth
  PB.DrawWidth = DrawWidth
End If
End Sub

Public Sub SetTurtleVisibility(bVisible As Boolean)
If ShowTurtle <> bVisible Then
  ShowTurtle = bVisible
  Call DrawTurtle
  
  If UseBackBuffer And AutoUpdate Then Call Update
End If
End Sub

Public Sub SetMoveDelay(NewDelay As Long)
MoveDelay = NewDelay
End Sub

Public Sub SetBackBuffer(Enabled As Boolean)
If UseBackBuffer <> Enabled Then
  If ShowTurtle Then Call DrawTurtle

  UseBackBuffer = Enabled
  
  If UseBackBuffer Then
    Set PB = BackBuffer
  Else
    Set PB = PrimarySurface
  End If
  
  PB.ForeColor = PenColor
  PB.BackColor = BackColor
  MoveToEx PB.hdc, CLng(x), CLng(y), ByVal 0 'Changeing AutoRedraw resets Cursor Pos
  hdc = PB.hdc
  
  If ShowTurtle Then Call DrawTurtle
  
  If UseBackBuffer And AutoUpdate Then Call Update
End If
End Sub

Public Sub SetAutoUpdate(Enabled As Boolean)
If AutoUpdate <> Enabled Then
  AutoUpdate = Enabled
End If
End Sub

Public Sub Update()
BitBlt PrimarySurface.hdc, 0, 0, Width, Height, BackBuffer.hdc, 0, 0, vbSrcCopy
End Sub

Private Sub DrawTurtle()
Dim P(0 To 4) As POINTAPI
Const Size As Long = 8
PB.DrawMode = vbInvert
PB.DrawWidth = 1

P(0).x = x
P(0).y = y
P(1).x = x + Sin((Angle + 120) * Deg2Rad) * Size
P(1).y = y - Cos((Angle + 120) * Deg2Rad) * Size
P(2).x = x + Sin(Angle * Deg2Rad) * Size
P(2).y = y - Cos(Angle * Deg2Rad) * Size
P(3).x = x + Sin((Angle + 240) * Deg2Rad) * Size
P(3).y = y - Cos((Angle + 240) * Deg2Rad) * Size
P(4) = P(0)

Polyline hdc, P(0), 5

PB.DrawWidth = DrawWidth
PB.DrawMode = PenMode
End Sub
