VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

'DefInt A-Z

' File Open/Save structures and declarations *****************************

Private Type OPENFILENAME
  lStructSize As Long         ' Same
  hWndOwner As Long           ' Was Integer
  hInstance As Long           ' Was Integer
  lpstrFilter As String       ' Was Long
  lpstrCustomFilter As String ' Was Long
  nMaxCustFilter As Long      ' Same
  nFilterIndex As Long        ' Same
  lpstrFile As String         ' Was Long
  nMaxFile As Long            ' Same
  lpstrFileTitle As String    ' Was Long
  nMaxFileTitle As Long       ' Same
  lpstrInitialDir As String   ' Was Long
  lpstrTitle As String        ' Was Long
  flags As Long               ' Same
  nFileOffset As Integer      ' Same
  nFileExtension As Integer   ' Same
  lpstrDefExt As String       ' Was Long
  lCustData As Long           ' Same
  lpfnHook As Long            ' Same
  lpTemplateName As String    ' Was long
End Type

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long


Const OFN_ALLOWMULTISELECT = &H200      ' See Help Note for LFN Behavior
Const OFN_CREATEPROMPT = &H2000
Const OFN_ENABLEHOOK = &H20
Const OFN_ENABLETEMPLATE = &H40
Const OFN_ENABLETEMPLATEHANDLE = &H80
Const OFN_EXPLORER = &H80000            ' Windows 95 Only
Const OFN_EXTENSIONDIFFERENT = &H400
Const OFN_FILEMUSTEXIST = &H1000
Const OFN_HIDEREADONLY = &H4
Const OFN_LONGNAMES = &H200000          ' Windows 95 Only
Const OFN_NOCHANGEDIR = &H8
Const OFN_NODEREFERENCELINKS = &H100000 ' Windows 95 Only
Const OFN_NOLONGNAMES = &H40000         ' Not Referenced in Help!
Const OFN_NONETWORKBUTTON = &H20000
Const OFN_NOREADONLYRETURN = &H8000
Const OFN_NOTESTFILECREATE = &H10000
Const OFN_NOVALIDATE = &H100
Const OFN_OVERWRITEPROMPT = &H2
Const OFN_PATHMUSTEXIST = &H800
Const OFN_READONLY = &H1
Const OFN_SHAREAWARE = &H4000
Const OFN_SHAREFALLTHROUGH = 2
Const OFN_SHARENOWARN = 1
Const OFN_SHAREWARN = 0
Const OFN_SHOWHELP = &H10

Private Const MAX_PATH As Long = 260

' ChooseColor structure and function declarations *************************

Private Type ChooseColor
  lStructSize As Long
  hWndOwner As Long
  hInstance As Long
  rgbResult As Long
  lpCustColors As Long
  flags As Long
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type

Private Declare Function ChooseColor Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As ChooseColor) As Long

Const CC_ENABLEHOOK = &H10
Const CC_ENABLETEMPLATE = &H20
Const CC_ENABLETEMPLATEHANDLE = &H40
Const CC_FULLOPEN = &H2
Const CC_PREVENTFULLOPEN = &H4
Const CC_RGBINIT = &H1
Const CC_SHOWHELP = &H8

' FONT STUFF
Const LF_FACESIZE = 32
    
Private Type LOGFONT
  lfHeight As Long
  lfWidth As Long
  lfEscapement As Long
  lfOrientation As Long
  lfWeight As Long
  lfItalic As Byte
  lfUnderline As Byte
  lfStrikeOut As Byte
  lfCharSet As Byte
  lfOutPrecision As Byte
  lfClipPrecision As Byte
  lfQuality As Byte
  lfPitchAndFamily As Byte
  lfFaceName(0 To LF_FACESIZE - 1) As Byte
End Type


Const LOGPIXELSY = 90    ' Logical pixels/inch in Y
Const CCHDEVICENAME = 32
Const CCHFORMNAME = 32

Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long

' ChooseFont structure and function declarations *************************

Private Type ChooseFont
  lStructSize As Long
  hWndOwner As Long          ' caller's window handle
  hDC As Long                ' printer DC/IC or NULL
  lpLogFont As Long          ' ptr. to a LOGFONT struct
  iPointSize As Long         ' 10 * size in points of selected font
  flags As Long              ' enum. type flags
  rgbColors As Long          ' returned text color
  lCustData As Long          ' data passed to hook fn.
  lpfnHook As Long           ' ptr. to hook function
  lpTemplateName As String   ' custom template name
  hInstance As Long          ' instance handle of.EXE that
                             '   contains cust. dlg. template
  lpszStyle As String        ' return the style field here
                             ' must be LF_FACESIZE or bigger
  nFontType As Integer       ' same value reported to the EnumFonts
                             '   call back with the extra FONTTYPE_
                             '   bits added
  MISSING_ALIGNMENT As Integer
  nSizeMin As Long           ' minimum pt size allowed &
  nSizeMax As Long           ' max pt size allowed if
                             '   CF_LIMITSIZE is used
End Type

Private Declare Function ChooseFont Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As ChooseFont) As Long
' nicht VB5 -> Fehler bei Schriftauswahl-Dialog
'Private Declare Function VarPtr Lib "VB40032" (lpVoid As Any) As Long 'Secret VB Runtime function

Const CF_ANSIONLY = &H400&
Const CF_APPLY = &H200&
Const CF_EFFECTS = &H100&
Const CF_ENABLEHOOK = &H8&
Const CF_ENABLETEMPLATE = &H10&
Const CF_ENABLETEMPLATEHANDLE = &H20&
Const CF_FIXEDPITCHONLY = &H4000&
Const CF_FORCEFONTEXIST = &H10000
Const CF_INITTOLOGFONTSTRUCT = &H40&
Const CF_LIMITSIZE = &H2000&
Const CF_NOFACESEL = &H80000
Const CF_NOSCRIPTSEL = &H800000
Const CF_NOSIMULATIONS = &H1000&
Const CF_NOSIZESEL = &H200000
Const CF_NOSTYLESEL = &H100000
Const CF_NOVECTORFONTS = &H800&
Const CF_NOVERTFONTS = &H1000000
Const CF_OWNERDISPLAY = &H80
Const CF_PRINTERFONTS = &H2
Const CF_SCALABLEONLY = &H20000
Const CF_SCREENFONTS = &H1
Const CF_SCRIPTSONLY = CF_ANSIONLY
Const CF_SELECTSCRIPT = &H400000
Const CF_SHOWHELP = &H4&
Const CF_TTONLY = &H40000
Const CF_USESTYLE = &H80&
Const CF_WYSIWYG = &H8000
Const CF_BOTH = (CF_SCREENFONTS Or CF_PRINTERFONTS)
Const CF_NOOEMFONTS = CF_NOVECTORFONTS

Const SIMULATED_FONTTYPE = &H8000
Const PRINTER_FONTTYPE = &H4000
Const SCREEN_FONTTYPE = &H2000
Const BOLD_FONTTYPE = &H100
Const ITALIC_FONTTYPE = &H200
Const REGULAR_FONTTYPE = &H400

Const WM_CHOOSEFONT_GETLOGFONT = (&H400 + 1) 'WM_USER + 1

Const LBSELCHSTRING = "commdlg_LBSelChangedNotify"
Const SHAREVISTRING = "commdlg_ShareViolation"
Const FILEOKSTRING = "commdlg_FileNameOK"
Const COLOROKSTRING = "commdlg_ColorOK"
Const SETRGBSTRING = "commdlg_SetRGBColor"
Const FINDMSGSTRING = "commdlg_FindReplace"
Const HELPMSGSTRING = "commdlg_help"

Const CD_LBSELNOITEMS = -1
Const CD_LBSELCHANGE = 0
Const CD_LBSELSUB = 1
Const CD_LBSELADD = 2
'
'' Printer related structures and function declarations ********************
'
'  Private Type PRINTDLG
'        lStructSize As Long
'        hWndOwner As Long
'        hDevMode As Long
'        hDevNames As Long
'        hDC As Long
'        flags As Long
'        nFromPage As Integer
'        nToPage As Integer
'        nMinPage As Integer
'        nMaxPage As Integer
'        nCopies As Integer
'        hInstance As Long
'        lCustData As Long
'        lpfnPrintHook As Long
'        lpfnSetupHook As Long
'        lpPrintTemplateName As String
'        lpSetupTemplateName As String
'        hPrintTemplate As Long
'        hSetupTemplate As Long
'    End Type
'
'    Private Declare Function PRINTDLG Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PRINTDLG) As Long
'
'Private Declare Function privateFree Lib "kernel32" (ByVal hMem As Long) As Long
'Private Declare Function privateLock Lib "kernel32" (ByVal hMem As Long) As Long
'Private Declare Function privateUnlock Lib "kernel32" (ByVal hMem As Long) As Long
'
'Const PD_ALLPAGES = &H0
'Const PD_SELECTION = &H1
'Const PD_PAGENUMS = &H2
'Const PD_NOSELECTION = &H4
'Const PD_NOPAGENUMS = &H8
'Const PD_COLLATE = &H10
'Const PD_PRINTTOFILE = &H20
'Const PD_PRINTSETUP = &H40
'Const PD_NOWARNING = &H80
'Const PD_RETURNDC = &H100
'Const PD_RETURNIC = &H200
'Const PD_RETURNDEFAULT = &H400
'Const PD_SHOWHELP = &H800
'Const PD_ENABLEPRINTHOOK = &H1000
'Const PD_ENABLESETUPHOOK = &H2000
'Const PD_ENABLEPRINTTEMPLATE = &H4000
'Const PD_ENABLESETUPTEMPLATE = &H8000
'Const PD_ENABLEPRINTTEMPLATEHANDLE = &H10000
'Const PD_ENABLESETUPTEMPLATEHANDLE = &H20000
'Const PD_USEDEVMODECOPIES = &H40000
'Const PD_DISABLEPRINTTOFILE = &H80000
'Const PD_HIDEPRINTTOFILE = &H100000
'
'Private Type DEVNAMES
'    wDriverOffset As Integer
'    wDeviceOffset As Integer
'    wOutputOffset As Integer
'    wDefault As Integer
'End Type
'
'Const DN_DEFAULTPRN = &H1
'
'' retrieves error value
'
'    Private Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long
'
''************************* end of Common Dialogs Declares ************
'
'' GLOBAL MEMORY Stuff
'
'    Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
'    Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
'    Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
'    Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
'
'
'Const GMEM_MOVEABLE = &H2
'Const GMEM_ZEROINIT = &H40
'Const GHND = (GMEM_MOVEABLE Or GMEM_ZEROINIT)
'
'    Private Declare Sub MemoryCopy Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal dwBytes As Long)
'
'' PRINTER stuff
'
'    Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
'
'  Private Type DEVMODE
'        dmDeviceName As String * CCHDEVICENAME
'        dmSpecVersion As Integer
'        dmDriverVersion As Integer
'        dmSize As Integer
'        dmDriverExtra As Integer
'        dmFields As Long
'        dmOrientation As Integer
'        dmPaperSize As Integer
'        dmPaperLength As Integer
'        dmPaperWidth As Integer
'        dmScale As Integer
'        dmCopies As Integer
'        dmDefaultSource As Integer
'        dmPrintQuality As Integer
'        dmColor As Integer
'        dmDuplex As Integer
'        dmYResolution As Integer
'        dmTTOption As Integer
'        dmCollate As Integer
'        dmFormName As String * CCHFORMNAME
'        dmUnusedPadding As Integer
'        dmBitsPerPel As Integer
'        dmPelsWidth As Long
'        dmPelsHeight As Long
'        dmDisplayFlags As Long
'        dmDisplayFrequency As Long
'    End Type

' *************** Browse For Folder ********************

Private Const BIF_BROWSEFORCOMPUTER = &H1000
Private Const BIF_BROWSEFORPRINTER = &H2000
Private Const BIF_BROWSEINCLUDEFILES = &H4000
Private Const BIF_BROWSEINCLUDEURLS = &H80
Private Const BIF_DONTGOBELOWDOMAIN = &H2
Private Const BIF_EDITBOX = &H10
Private Const BIF_NEWDIALOGSTYLE = &H40
Private Const BIF_RETURNFSANCESTORS = &H8
Private Const BIF_RETURNONLYFSDIRS = &H1
Private Const BIF_SHAREABLE = &H8000
Private Const BIF_STATUSTEXT = &H4
Private Const BIF_USENEWUI = &H40
Private Const BIF_VALIDATE = &H20

Private Type BROWSEINFO
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type

Private Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pIDL As Long, ByVal pszPath As String) As Long

' ***************** Eingenschaften Variablen *******************

Public Font As New StdFont
Public Color As Long
Public Filename As String
Public FilePath As String
Public FileTitle As String
Public FileExtension As String
Public Filter As String
Public FilterIndex As Long
Public InitDir As String
Public DefaultExt As String
Public Folder As String

Public DialogTitle As String

Public FromPage As Integer
Public ToPage As Integer
Public Min As Integer
Public Max As Integer
Public Copies As Integer

Private hWndOwner As Long
Private hDCOwner As Long

Public Function ShowFont() As Boolean

Dim A As ChooseFont
Dim F As LOGFONT
Dim FontName As String

A.lpLogFont = VarPtr(F)
A.hDC = hDCOwner
A.lStructSize = Len(A)
A.hWndOwner = hWndOwner
A.flags = CF_SCREENFONTS Or CF_EFFECTS
A.nFontType = SCREEN_FONTTYPE

If ChooseFont(A) Then ' **************** Show Dialog ****************
  ShowFont = True
  
  FontName = StrConv(F.lfFaceName, vbUnicode)
  Font.Name = Left$(FontName, InStr(1, FontName, vbNullChar) - 1)
  Font.Size = CLng(Abs(F.lfHeight * (72 / GetDeviceCaps(hDCOwner, LOGPIXELSY))))
  Font.Italic = F.lfItalic
  Font.Strikethrough = F.lfStrikeOut
  Font.Underline = F.lfUnderline
  
  Font.Bold = F.lfWeight >= 500
End If
End Function

Public Function ShowColor() As Boolean
Dim C As ChooseColor
Dim Address As Long
Dim i As Long

Dim ClrArray() As Long
ReDim ClrArray(15) As Long

For i = 0 To UBound(ClrArray)
  ClrArray(i) = &HFFFFFF
Next

C.lStructSize = Len(C)
C.hWndOwner = hWndOwner
C.lpCustColors = VarPtr(ClrArray(0)) 'Address
C.rgbResult = Color
C.flags = CC_RGBINIT Or CC_FULLOPEN

If ChooseColor(C) Then
  ShowColor = True
  Color = C.rgbResult
End If
End Function






Public Function ShowOpen() As Boolean
Dim O As OPENFILENAME

O.lStructSize = Len(O)
O.hWndOwner = hWndOwner
O.flags = OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
O.nFilterIndex = FilterIndex
O.nMaxFile = MAX_PATH
O.lpstrFile = Filename & String$(MAX_PATH - Len(Filename) + 1, 0)
O.lpstrInitialDir = InitDir
O.lpstrFilter = Replace$(Filter, "|", vbNullChar) & vbNullChar
O.lpstrDefExt = DefaultExt
O.lpstrTitle = DialogTitle

If GetOpenFileName(O) Then ' **************** ShowDialog ****************
  ShowOpen = True
  Filename = Left(O.lpstrFile, InStr(O.lpstrFile, Chr$(0)) - 1)
  FilePath = Left$(Filename, O.nFileOffset)
  FileTitle = Right$(Filename, Len(Filename) - O.nFileOffset)
  If O.nFileExtension Then
    FileExtension = Right$(Filename, Len(Filename) - O.nFileExtension)
  Else
    FileExtension = ""
  End If
End If
End Function



Public Function ShowSave() As Boolean

Dim S As OPENFILENAME

S.lStructSize = Len(S)
S.hWndOwner = hWndOwner
S.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
S.nFilterIndex = FilterIndex
S.nMaxFile = MAX_PATH
S.lpstrFile = Filename & String$(MAX_PATH - Len(Filename) + 1, 0)
S.lpstrInitialDir = InitDir
S.lpstrFilter = Replace$(Filter, "|", vbNullChar) & vbNullChar
S.lpstrDefExt = DefaultExt
S.lpstrTitle = DialogTitle

If GetSaveFileName(S) Then ' **************** ShowDialog ****************
  ShowSave = True
  Filename = Left$(S.lpstrFile, InStr(S.lpstrFile, vbNullChar) - 1)
  FilePath = Left$(Filename, S.nFileOffset)
  FileTitle = Right$(Filename, Len(Filename) - S.nFileOffset)
  If S.nFileExtension Then
    FileExtension = Right$(Filename, Len(Filename) - S.nFileExtension)
  Else
    FileExtension = ""
  End If
End If
End Function

Public Function ShowFolder() As Boolean
Dim pIDL As Long
Dim BrInfo As BROWSEINFO

With BrInfo
  .hOwner = hWndOwner
  .pidlRoot = 0
  .lpszTitle = DialogTitle
  .ulFlags = BIF_RETURNONLYFSDIRS
End With

pIDL = SHBrowseForFolder(BrInfo)
If pIDL Then
  Folder = String$(MAX_PATH + 1, 0)
  
  If SHGetPathFromIDList(ByVal pIDL, ByVal Folder) Then
    ShowFolder = True
    Folder = Left(Folder, InStr(Folder, Chr$(0)) - 1)
  End If
End If
End Function


Private Sub Class_Initialize()
FilterIndex = 1
End Sub

Public Sub Init(hwnd As Long, hDC As Long)
hWndOwner = hwnd
hDCOwner = hDC
End Sub
