VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCodeEditor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Function MoveToEx Lib "gdi32.dll" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByRef lpPoint As Any) As Long
Private Declare Function LineTo Lib "gdi32.dll" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long

Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const EM_GETFIRSTVISIBLELINE As Long = &HCE
Private Const EM_GETLINECOUNT As Long = &HBA
Private Const EM_GETLINE As Long = &HC4
Private Const EM_LINELENGTH As Long = &HC1
Private Const EM_LINEINDEX As Long = &HBB
Private Const EM_LINEFROMCHAR As Long = &HC9
Private Const EM_POSFROMCHAR As Long = &HD6&
Private Declare Function DrawIconEx Lib "user32.dll" (ByVal hDC As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
Private Declare Function Rectangle Lib "gdi32.dll" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function GetKeyState Lib "user32.dll" (ByVal nVirtKey As Long) As Long
Private Const VK_SHIFT As Long = &H10
Private Const VK_CONTROL As Long = &H11
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (ByRef Destination As Any, ByVal Length As Long)


Private Const ArrowBarWidth As Long = 20
Public WithEvents PB As PictureBox
Attribute PB.VB_VarHelpID = -1
Public WithEvents TB As TextBox
Attribute TB.VB_VarHelpID = -1

Private WithEvents tmrAfterKeyPress As Timer
Attribute tmrAfterKeyPress.VB_VarHelpID = -1

Private ToolTip As clsTooltip
Private CommandList As clsCommandList

Private Height As Long 'Client Area

Private CurrentArrowLine As Long
Private ArrowIcon As StdPicture

Private Const TextHeight As Long = 16
Private Const TextWidth As Long = 8
'Private Const TabWidth As Long = 2

Private CurrentLine As Long
Private CurrentCol As Long
Private NumLines As Long

Private Type UndoStackEntry
  Text As String
  SelStart As Long
End Type
Private UndoStack() As UndoStackEntry
Private NumUndoStackEntries As Long
Private Const MaxUndoStackEntries As Long = 50
Private UndoStackIndex As Long
Private bUndoRedoAction As Boolean

Public Changed As Boolean

Event CursorPosChanged(Line As Long, Col As Long)
Event LineCountChanged(NumLines As Long)
Event Change()
Event FileDragDrop(Filename As String)

Private Sub Class_Initialize()
CurrentArrowLine = -1
Set tmrAfterKeyPress = Form1.Controls.Add("VB.Timer", "tmrAfterKeyPress" & ObjPtr(Me))
tmrAfterKeyPress.Interval = 1
Set ArrowIcon = LoadResPicture("Arrow", vbResIcon)
End Sub

Private Sub Class_Terminate()
On Error Resume Next
Form1.Controls.Remove tmrAfterKeyPress.Name
Set tmrAfterKeyPress = Nothing
End Sub

Public Sub Init(CodeTextBox As TextBox, ArrowBarPictureBox As PictureBox)
Set TB = CodeTextBox
Set PB = ArrowBarPictureBox

Set ToolTip = New clsTooltip
ToolTip.Init TB

Set CommandList = New clsCommandList
End Sub

Public Sub Resize(NewHeight As Long)
Height = NewHeight - 4
PB.ForeColor = 0
MoveToEx PB.hDC, ArrowBarWidth - 1, 0, ByVal 0
LineTo PB.hDC, ArrowBarWidth - 1, Height
PB.ForeColor = PB.BackColor
PB.Refresh
End Sub

Public Sub SelectLine(Line As Long)
TB.SelStart = GetLineStartCharIndex(Line)
TB.SelLength = GetLineLength(TB.SelStart)
TB.SetFocus
End Sub

Public Sub Undo()
If CanUndo Then
  UndoStackIndex = UndoStackIndex - 1
  bUndoRedoAction = True
  TB.Text = UndoStack(UndoStackIndex).Text
  TB.SelStart = UndoStack(UndoStackIndex).SelStart
  bUndoRedoAction = False
End If
End Sub

Public Property Get CanUndo() As Boolean
CanUndo = UndoStackIndex <> 0
End Property

Public Sub Redo()
If CanRedo Then
  UndoStackIndex = UndoStackIndex + 1
  bUndoRedoAction = True
  TB.Text = UndoStack(UndoStackIndex).Text
  TB.SelStart = UndoStack(UndoStackIndex).SelStart
  bUndoRedoAction = False
End If
End Sub

Public Property Get CanRedo()
CanRedo = UndoStackIndex < NumUndoStackEntries - 1
End Property

Public Sub ClearUndoStack()
Erase UndoStack
NumUndoStackEntries = 0
End Sub

Public Sub AddUndoStackEntry()
If UndoStackIndex < NumUndoStackEntries - 1 Then Call CutUndoStack

If NumUndoStackEntries < MaxUndoStackEntries Then
  NumUndoStackEntries = NumUndoStackEntries + 1
  ReDim Preserve UndoStack(0 To NumUndoStackEntries - 1)
Else
  UndoStack(0).Text = vbNullString
  CopyMemory ByVal VarPtr(UndoStack(0)), ByVal VarPtr(UndoStack(1)), (NumUndoStackEntries - 1) * LenB(UndoStack(0))
  ZeroMemory ByVal VarPtr(UndoStack(NumUndoStackEntries - 1)), LenB(UndoStack(0))
End If
UndoStack(NumUndoStackEntries - 1).Text = TB.Text
UndoStack(NumUndoStackEntries - 1).SelStart = TB.SelStart
UndoStackIndex = NumUndoStackEntries - 1
End Sub

Private Sub CutUndoStack()
NumUndoStackEntries = UndoStackIndex + 1
ReDim Preserve UndoStack(0 To NumUndoStackEntries - 1)
End Sub

Public Sub CommentBlock(Undo As Boolean)
Dim W As Long
Dim OldSelStart As Long
Dim OldSelLength As Long
Dim StartLine As Long
Dim EndLine As Long
Dim DeltaLength As Long
OldSelStart = TB.SelStart
OldSelLength = TB.SelLength
StartLine = GetLineFromCharIndex(TB.SelStart)
If TB.SelLength Then EndLine = GetLineFromCharIndex(TB.SelStart + TB.SelLength - 1) Else EndLine = StartLine

For W = StartLine To EndLine
  TB.SelStart = GetLineStartCharIndex(W)
  If Undo Then
    TB.SelLength = 2
    If TB.SelText = "//" Then
      TB.SelText = ""
      DeltaLength = DeltaLength - 2
    End If
  Else
    TB.SelText = "//"
    DeltaLength = DeltaLength + 2
  End If
Next

If StartLine <> EndLine Then
  TB.SelStart = OldSelStart ' + (2 * Sgn(DeltaLength))
  TB.SelLength = OldSelLength + DeltaLength ' - (2 * Sgn(DeltaLength))
Else
  TB.SelStart = OldSelStart + DeltaLength
  If TB.SelStart < GetLineStartCharIndex(StartLine) Then TB.SelStart = GetLineStartCharIndex(StartLine)
  TB.SelLength = 0
End If
End Sub

Public Sub ShowCommandList()
CommandList.Show CursorPosToPixel(TB.SelStart, True, False)
CommandList.StartPos = TB.SelStart
End Sub

Public Sub LockEditor(bLock As Boolean)
TB.Locked = bLock
TB.Refresh
End Sub

'#################################################################################################################
'############################################# PictureBox Functions ##############################################
'#################################################################################################################
'VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
Private Sub PB_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

End Sub

Private Sub PB_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
If Data.GetFormat(15) Then RaiseEvent FileDragDrop(Data.Files(1))
End Sub
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

'#################################################################################################################
'############################################# PictureBox Functions ##############################################
'#################################################################################################################
'VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
Public Sub SetArrow(Line As Long)
Dim Y As Long
Dim FirstLine As Long
If CurrentArrowLine <> Line Then
  FirstLine = GetFirstVisibleLine()
  If CurrentArrowLine <> -1 Then
    Y = (CurrentArrowLine - FirstLine) * TextHeight
    Rectangle PB.hDC, 3, Y, ArrowBarWidth - 1, Y + 16
  End If
  If Line <> -1 Then
    Y = (Line - FirstLine) * TextHeight
    DrawIconEx PB.hDC, 3, Y, ArrowIcon, 16, 16, 0, 0, 3
  End If
  PB.Refresh
  CurrentArrowLine = Line
End If
End Sub
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

'#################################################################################################################
'################################################ TextBox Events #################################################
'#################################################################################################################
'VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
Private Sub TB_KeyPress(KeyAscii As Integer)
Dim NumSpacesBefore As Long
Dim Line As String
Dim Col As Long
Dim Length As Long
Dim NewCol As Long
Dim StartLine As Long
Dim EndLine As Long
Dim W As Long
Dim OldSelStart As Long
Dim OldSelLength As Long
Dim DeltaLength As Long

If TB.Locked Then
  KeyAscii = 0
  Exit Sub
End If


If KeyAscii = vbKeyTab Then
  CommandList.Hide
  ToolTip.Hide
  KeyAscii = 0
  If TB.SelLength Then
    StartLine = GetLineFromCharIndex(TB.SelStart)
    EndLine = GetLineFromCharIndex(TB.SelStart + TB.SelLength - 1)
  End If
  
  If StartLine = EndLine Then
    TB.SelText = Space$(Options.TabWidth)
  Else
    OldSelStart = TB.SelStart
    OldSelLength = TB.SelLength
    If GetKeyState(VK_SHIFT) And &HFF00& Then
      For W = StartLine To EndLine
        TB.SelStart = GetLineStartCharIndex(W)
        For Length = Options.TabWidth To 1 Step -1
          TB.SelLength = Length
          If TB.SelText = Space$(Length) Then
            TB.SelText = ""
            DeltaLength = DeltaLength - Length
            Exit For
          End If
        Next
      Next
    Else
      For W = StartLine To EndLine
        TB.SelStart = GetLineStartCharIndex(W)
        TB.SelText = Space$(Options.TabWidth)
        DeltaLength = DeltaLength + Options.TabWidth
      Next
    End If
    TB.Refresh
    TB.SelStart = OldSelStart
    TB.SelLength = OldSelLength + DeltaLength
  End If
  ToolTip.Hide
End If
If KeyAscii = vbKeyReturn Then
  Line = GetLineText(CurrentLine)
  NumSpacesBefore = Len(Left$(Line, CurrentCol)) - Len(LTrim$(Left$(Line, CurrentCol)))
  ToolTip.Hide
  CommandList.Hide
  TB.SelText = vbCrLf & Space$(NumSpacesBefore)
  KeyAscii = 0
End If
If KeyAscii = vbKeyBack Then
  Line = GetLineText(CurrentLine)
  Col = CurrentCol
  If Col Then
    If Left$(Line, Col) = Space$(Col) Then
      If Col Mod Options.TabWidth = 0 Then
        NewCol = Col - Options.TabWidth
        Length = Options.TabWidth
      Else
        NewCol = (Col \ Options.TabWidth) * Options.TabWidth
        Length = (Col - NewCol)
      End If
      
      TB.SelStart = GetLineStartCharIndex(CurrentLine) + NewCol
      TB.SelLength = Length
    End If
  End If
End If

If KeyAscii = vbKeySpace And ((GetKeyState(VK_CONTROL) And &HFF00&) <> 0) Then
  Call ShowCommandList
  KeyAscii = 0
ElseIf (KeyAscii = vbKeySpace Or KeyAscii = Asc("(")) And CommandList.Visible Then
  Length = TB.SelStart - CommandList.StartPos
  TB.SelStart = CommandList.StartPos
  TB.SelLength = Length
  TB.SelText = CommandList.SelectedItem
  CommandList.Hide
  Call UpdateCursorPos
ElseIf KeyAscii = vbKeyEscape Then
  CommandList.Hide
End If

If Options.IntelliSense Then
  If CurrentCol Then
    If KeyAscii = vbKeySpace Then
      Dim strCmd As String
      Dim Cmd As enmCommand
      Line = GetLineText(CurrentLine)
      strCmd = LTrim$(Left$(Line, CurrentCol))
      If InStr(1, strCmd, " ") = 0 Then
        Cmd = LineAnalyzer.GetCommandIndex(strCmd)
        If Cmd Then
          If CommandsDB.CommandParams(Cmd).Usage And cuPrimaryCommand Then
            ToolTip.Show CommandsDB.CommandParams(Cmd), CursorPosToPixel(TB.SelStart, True, True)
          Else
            ToolTip.Hide
          End If
        Else
          ToolTip.Hide
        End If
      End If
    End If
    If KeyAscii = Asc("(") Then
      If CurrentCol Then
        Dim LastSpacePos As Long
        Line = GetLineText(CurrentLine)
        LastSpacePos = InStrRev(Line, " ", CurrentCol)
        If LastSpacePos Then
          strCmd = Mid$(Line, LastSpacePos + 1, CurrentCol - LastSpacePos)
          Cmd = LineAnalyzer.GetCommandIndex(strCmd)
          If Cmd Then
            If CommandsDB.CommandParams(Cmd).Usage And cuParameter Then
              ToolTip.Show CommandsDB.CommandParams(Cmd), CursorPosToPixel(TB.SelStart, True, True)
            Else
              ToolTip.Hide
            End If
          Else
            ToolTip.Hide
          End If
        Else
          ToolTip.Hide
        End If
      Else
        ToolTip.Hide
      End If
    End If
    If KeyAscii = Asc(")") Then
      Dim BracketPos As Long
      Dim SpacePos As Long
      Line = GetLineText(CurrentLine)
      BracketPos = InStrRev(Line, "(", CurrentCol)
      If BracketPos > 1 Then
        BracketPos = InStrRev(Line, "(", BracketPos - 1)
        If BracketPos > 1 Then
          SpacePos = InStrRev(Line, " ", BracketPos - 1)
          If SpacePos Then
            strCmd = Mid$(Line, SpacePos + 1, BracketPos - SpacePos - 1)
            Cmd = LineAnalyzer.GetCommandIndex(strCmd)
            If Cmd Then
              If CommandsDB.CommandParams(Cmd).Usage And cuParameter Then
                ToolTip.Show CommandsDB.CommandParams(Cmd), CursorPosToPixel(TB.SelStart, True, True)
              Else
                ToolTip.Hide
              End If
            Else
              ToolTip.Hide
            End If
          Else
            ToolTip.Hide
            'Debug.Assert 0
          End If
        Else
          NumSpacesBefore = Len(Line) - Len(LTrim$(Line))
          SpacePos = InStr(NumSpacesBefore + 1, Line, " ")
          If SpacePos Then
            strCmd = LTrim$(Left$(Line, SpacePos - 1))
            Cmd = LineAnalyzer.GetCommandIndex(strCmd)
            If Cmd Then
              If CommandsDB.CommandParams(Cmd).Usage And cuPrimaryCommand Then
                ToolTip.Show CommandsDB.CommandParams(Cmd), CursorPosToPixel(TB.SelStart - (CurrentCol - SpacePos) - 1, True, True)
              Else
                ToolTip.Hide
              End If
            Else
              ToolTip.Hide
            End If
          Else
            ToolTip.Hide
          End If
        End If
      Else
        ToolTip.Hide
      End If
    End If
  Else
    ToolTip.Hide
  End If
End If

End Sub

Private Sub TB_KeyDown(KeyCode As Integer, Shift As Integer)
If TB.Locked Then
  KeyCode = 0
  Exit Sub
End If
  
tmrAfterKeyPress.Tag = KeyCode
tmrAfterKeyPress.Enabled = True

If Options.IntelliSense Then
  If KeyCode = vbKeyDown Or KeyCode = vbKeyUp Then ToolTip.Hide
End If

If CommandList.Visible Then
  If KeyCode = vbKeyDown Then CommandList.MoveSelectionDown: KeyCode = 0
  If KeyCode = vbKeyUp Then CommandList.MoveSelectionUp: KeyCode = 0
  If KeyCode = vbKeyLeft Or KeyCode = vbKeyRight Then CommandList.Hide
End If
End Sub

Private Sub TB_LostFocus()
ToolTip.Hide
If Not Form1.ActiveControl Is CommandList.LVW Then CommandList.Hide
End Sub

Private Sub TB_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button Then Call TB_MouseDown(Button, Shift, X, Y)
End Sub

Private Sub TB_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Call UpdateCursorPos
ToolTip.Hide
CommandList.Hide
End Sub

Private Sub TB_DblClick()
Call UpdateCursorPos
End Sub

Private Sub TB_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
If Data.GetFormat(15) Then RaiseEvent FileDragDrop(Data.Files(1))
End Sub

Private Sub TB_Change()
Changed = True

If CommandList.Visible Then
  If TB.SelStart >= CommandList.StartPos Then
    CommandList.FindItem Mid$(TB.Text, CommandList.StartPos + 1, (TB.SelStart - CommandList.StartPos))
  Else
    CommandList.Hide
  End If
End If

If bUndoRedoAction = False Then Call AddUndoStackEntry

RaiseEvent Change
End Sub

Private Sub tmrAfterKeyPress_Timer()
tmrAfterKeyPress.Enabled = False

Call UpdateLineCount
Call UpdateCursorPos
End Sub
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

Private Sub UpdateCursorPos()
Dim L As Long
Dim C As Long
L = GetCurrentLine
C = GetCurrentCol
If L <> CurrentLine Or C <> CurrentCol Then
  CurrentLine = L
  CurrentCol = C
  RaiseEvent CursorPosChanged(L, C)
End If
End Sub

Private Sub UpdateLineCount()
Dim L As Long
L = GetLineCount()
If L <> NumLines Then
  NumLines = L
  RaiseEvent LineCountChanged(L)
End If
End Sub

'#################################################################################################################
'############################################### TextBox Functions ###############################################
'#################################################################################################################
Private Function GetCurrentLine() As Long
GetCurrentLine = SendMessage(TB.hwnd, EM_LINEFROMCHAR, ByVal TB.SelStart, ByVal 0)
End Function

Private Function GetCurrentCol() As Long
GetCurrentCol = TB.SelStart - GetLineStartCharIndex(GetCurrentLine)
End Function

Private Function GetLineFromCharIndex(CharIndex As Long) As Long
GetLineFromCharIndex = SendMessage(TB.hwnd, EM_LINEFROMCHAR, ByVal CharIndex, ByVal 0)
End Function

Private Function GetLineStartCharIndex(Line As Long) As Long
GetLineStartCharIndex = SendMessage(TB.hwnd, EM_LINEINDEX, ByVal Line, ByVal 0)
End Function

Private Function GetLineText(Line As Long) As String
Dim L As Long
GetLineText = Space$(256)
L = SendMessage(TB.hwnd, EM_GETLINE, Line, ByVal GetLineText)
GetLineText = Left$(GetLineText, L)
End Function

Private Function GetLineLength(CharacterIndex As Long) As Long
GetLineLength = SendMessage(TB.hwnd, EM_LINELENGTH, ByVal CharacterIndex, ByVal 0)
End Function

Private Function GetFirstVisibleLine() As Long
GetFirstVisibleLine = SendMessage(TB.hwnd, EM_GETFIRSTVISIBLELINE, ByVal 0, ByVal 0)
End Function

Private Function GetLineCount() As Long
GetLineCount = SendMessage(TB.hwnd, EM_GETLINECOUNT, ByVal 0, ByVal 0)
End Function

Friend Function CursorPosToPixel(CharacterIndex As Long, BottomPos As Boolean, RightPos As Boolean) As POINTAPI
Dim Ret As Long
Dim LineStartCharIndex As Long
Dim Col As Long
Dim i As Integer
  
LineStartCharIndex = GetLineStartCharIndex(GetLineFromCharIndex(CharacterIndex))
Ret = SendMessage(TB.hwnd, EM_POSFROMCHAR, LineStartCharIndex, ByVal 0)

With CursorPosToPixel
  CopyMemory i, Ret, 2
  .X = CLng(i) + (TextWidth And RightPos) + TB.Left + ((CharacterIndex - LineStartCharIndex) * TextWidth)
  CopyMemory i, ByVal VarPtr(Ret) + 2, 2
  .Y = CLng(i) + (TextHeight And BottomPos) + TB.Top
End With
End Function
