VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCommandList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Private Const LVM_FIRST As Long = &H1000
Private Const LVM_SETCOLUMNWIDTH As Long = (LVM_FIRST + 30)
Private Const LVSCW_AUTOSIZE As Long = -1
Private Declare Function GetSystemMetrics Lib "user32.dll" (ByVal nIndex As Long) As Long
Private Const SM_CXVSCROLL As Long = 2

Private Const NumVisbleItems As Long = 8

Public WithEvents LVW As MSComctlLib.ListView
Attribute LVW.VB_VarHelpID = -1
Private PB As PictureBox

Public StartPos As Long
Public Visible As Boolean

Private Sub Class_Terminate()
On Error Resume Next
Form1.Controls.Remove LVW.Name
Set LVW = Nothing
Form1.Controls.Remove PB.Name
Set PB = Nothing
End Sub

Private Sub Class_Initialize()
Set LVW = Form1.Controls.Add("MSComctlLib.ListViewCtrl.2", "lvwCommandList")
Set LVW.SmallIcons = Form1.imlCommandList
LVW.View = lvwReport
LVW.Appearance = ccFlat
LVW.HideColumnHeaders = True
LVW.HideSelection = False
LVW.ColumnHeaders.Add , , "", 1
LVW.TabStop = False
Set PB = Form1.Controls.Add("VB.PictureBox", "picCommandInfo")
PB.Appearance = ccFlat 'ComCtl Constant
PB.BackColor = vbInfoBackground
PB.ForeColor = vbInfoText
PB.ScaleMode = vbPixels
PB.AutoRedraw = True
PB.TabStop = False

Dim W As Long
Dim N As Long
Dim Width As Long
Dim DBEntry As CommandParams
Dim S As String

For W = 1 To CommandsDB.NumNativeCommands
  DBEntry = CommandsDB.CommandParams(W)
  For N = 0 To DBEntry.NumNames - 1
    If Len(DBEntry.Names(N)) Then 'Sort out Math Command
      LVW.ListItems.Add(, , DBEntry.Names(N), , IIf(DBEntry.Usage = cuParameter, 2, 1)).Tag = W
    End If
  Next
Next

SendMessage LVW.hwnd, LVM_SETCOLUMNWIDTH, 0, LVSCW_AUTOSIZE


LVW.SortKey = 0
LVW.Sorted = True
LVW.Sorted = False


For W = 1 To LVW.ColumnHeaders.Count
  Width = Width + LVW.ColumnHeaders(W).Width
Next

LVW.Width = Width + GetSystemMetrics(SM_CXVSCROLL)
LVW.Height = LVW.ListItems(1).Height * NumVisbleItems + 2
End Sub

Friend Sub Show(Pos As POINTAPI)
LVW.Move Pos.X, Pos.Y
LVW.ListItems(1).Selected = True
LVW.ListItems(1).EnsureVisible
Call DisplayCommandInfo(LVW.ListItems(1).Text, LVW.ListItems(1).Tag)
LVW.Visible = True
LVW.ZOrder vbBringToFront
Visible = True
PB.Visible = True
PB.ZOrder vbBringToFront
End Sub

Public Sub FindItem(Cmd As String)
Dim W As Long
For W = 1 To LVW.ListItems.Count
  With LVW.ListItems(W)
    If LCase$(Left$(.Text, Len(Cmd))) = LCase$(Cmd) Then
      .Selected = True
      .EnsureVisible
      Call DisplayCommandInfo(.Text, .Tag)
      Exit Sub
    End If
  End With
Next
End Sub

Private Sub DisplayCommandInfo(strCmd As String, Cmd As enmCommand)
Dim Text As String
Dim W As Long
Dim DBEntry As CommandParams
DBEntry = CommandsDB.CommandParams(Cmd)

If DBEntry.Usage = cuPrimaryCommand Then
  Text = "Command: " & strCmd
Else
  Text = "Function: " & strCmd
End If

If DBEntry.MaxParameterCount Then
  If DBEntry.Usage = cuParameter Then Text = Text & "(" Else Text = Text & " "
  For W = 0 To Min(DBEntry.MaxParameterCount - 1, UBound(DBEntry.PrametersInfo))
    If W Then Text = Text & " "
    If W > DBEntry.MinParameterCount - 1 Then
      Text = Text & "[" & DBEntry.PrametersInfo(W).Name & "]"
    Else
      Text = Text & "<" & DBEntry.PrametersInfo(W).Name & ">"
    End If
  Next
  If DBEntry.Usage = cuParameter Then Text = Text & ")"
End If

Dim X As Long

If DBEntry.NumNames <> 1 Then
  Text = Text & vbCrLf & vbCrLf & "Alternatives: "
  For W = 0 To DBEntry.NumNames - 1
    If DBEntry.Names(W) <> strCmd And Len(DBEntry.Names(W)) Then
      If X Then Text = Text & ", "
      Text = Text & DBEntry.Names(W)
      X = X + 1
    End If
  Next
End If

Text = Text & vbCrLf & vbCrLf & "Description:" & vbCrLf & DBEntry.Description

PB.Move LVW.Left + LVW.Width - 1, LVW.Top, PB.TextWidth(Text) + 4, PB.TextHeight(Text) + 4
PB.Cls
PB.Print Text
End Sub

Public Sub MoveSelectionUp()
If LVW.SelectedItem.Index > 1 Then
  With LVW.ListItems(LVW.SelectedItem.Index - 1)
    .Selected = True
    .EnsureVisible
    Call DisplayCommandInfo(.Text, .Tag)
  End With
End If
End Sub

Public Sub MoveSelectionDown()
If LVW.SelectedItem.Index < LVW.ListItems.Count Then
  With LVW.ListItems(LVW.SelectedItem.Index + 1)
    .Selected = True
    .EnsureVisible
    Call DisplayCommandInfo(.Text, .Tag)
  End With
End If
End Sub

Public Property Get SelectedItem()
If Not LVW.SelectedItem Is Nothing Then SelectedItem = LVW.SelectedItem.Text
End Property

Public Sub Hide()
LVW.Visible = False
PB.Visible = False
Visible = False
End Sub

Private Sub LVW_GotFocus()
Form1.txtCode.SetFocus
End Sub

Private Sub LVW_ItemClick(ByVal Item As MSComctlLib.ListItem)
Call DisplayCommandInfo(Item.Text, Item.Tag)
End Sub
