VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsConsole"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Private Const LVM_FIRST As Long = &H1000
Private Const LVM_SETCOLUMNWIDTH As Long = (LVM_FIRST + 30)
Private Const LVSCW_AUTOSIZE As Long = -1
Private Const WM_SETREDRAW As Long = &HB
Private Declare Sub GetSystemTime Lib "kernel32.dll" (ByRef lpSystemTime As SYSTEMTIME)
Private Type SYSTEMTIME
  wYear As Integer
  wMonth As Integer
  wDayOfWeek As Integer
  wDay As Integer
  wHour As Integer
  wMinute As Integer
  wSecond As Integer
  wMilliseconds As Integer
End Type


Public Enum enmConsleIcons
  ciParse = 1
  ciParseOK
  ciRun
  ciLog
  ciPause
  ciResume
  ciStop
  ciResult
  ciWarning
  ciError
End Enum

Private TimeDeltaMS As Long

Private WithEvents LVW As ListView
Attribute LVW.VB_VarHelpID = -1
Private WithEvents mnuCopyLine As Menu
Attribute mnuCopyLine.VB_VarHelpID = -1
Private WithEvents mnuCopyAll As Menu
Attribute mnuCopyAll.VB_VarHelpID = -1
Private WithEvents mnuClear As Menu
Attribute mnuClear.VB_VarHelpID = -1

Private Sub Class_Initialize()
Set LVW = Form1.lvwConsoleOutput
Set mnuCopyLine = Form1.mnuCopyConsoleLine
Set mnuCopyAll = Form1.mnuCopyConsoleAll
Set mnuClear = Form1.mnuClearConsole

Dim TStart As SYSTEMTIME
Dim T As SYSTEMTIME
Dim ms As Long
GetSystemTime TStart
Do
  GetSystemTime T
Loop Until T.wMilliseconds <> TStart.wMilliseconds
ms = timeGetTime
TimeDeltaMS = T.wMilliseconds - (ms Mod 1000)
If TimeDeltaMS < 0 Then TimeDeltaMS = 1000 + TimeDeltaMS
End Sub


Public Sub PrintText(Text As String, Optional Color As Long = vbBlack, Optional Icon As enmConsleIcons = 0)
SendMessage LVW.Parent.hwnd, WM_SETREDRAW, 0&, ByVal 0&

With LVW.ListItems.Add(, , GetPrompt)
  .ForeColor = Color
  .ListSubItems.Add(, , Text).ForeColor = Color
  .SmallIcon = Icon
  .EnsureVisible
End With
SendMessage LVW.hwnd, LVM_SETCOLUMNWIDTH, 1, ByVal LVSCW_AUTOSIZE
SendMessage LVW.Parent.hwnd, WM_SETREDRAW, 1&, ByVal 0&
LVW.Refresh
End Sub

Public Sub AddEmptyLine()
With LVW.ListItems.Add(, , "")
  .ListSubItems.Add , , ""
  .EnsureVisible
End With
LVW.Refresh
End Sub

Public Sub Clear()
LVW.ListItems.Clear
LVW.Refresh
End Sub

Public Property Get IsEmpty() As Boolean
IsEmpty = LVW.ListItems.Count = 0
End Property


Private Function GetPrompt() As String
GetPrompt = Time$ & ":" & Right$("00" & CStr((timeGetTime Mod 1000) + TimeDeltaMS), 3)
End Function

Private Sub LVW_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button = 2 Then
  If LVW.ListItems.Count Then
    Dim SI As ListItem
    Set SI = LVW.HitTest(X, Y)
    If SI Is Nothing Then
      mnuCopyLine.Enabled = False
      Set LVW.SelectedItem = Nothing
    Else
      mnuCopyLine.Enabled = True
      SI.Selected = True
    End If
    
    Form1.PopupMenu Form1.mnuConsoleContextMenu
  End If
End If
End Sub

Private Sub mnuClear_Click()
LVW.ListItems.Clear
End Sub

Private Sub mnuCopyAll_Click()
Dim W As Long
Dim S As String
For W = 1 To LVW.ListItems.Count
  S = S & LVW.ListItems(W).Text & " " & LVW.ListItems(W).ListSubItems(1).Text & vbCrLf
Next
Clipboard.Clear
Clipboard.SetText S
End Sub

Private Sub mnuCopyLine_Click()
Clipboard.Clear
Clipboard.SetText LVW.SelectedItem.Text & " " & LVW.SelectedItem.ListSubItems(1).Text
End Sub
